---
title: Symbol.for()
slug: Web/JavaScript/Reference/Global_Objects/Symbol/for
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Symbol
---
<div>{{JSRef}}</div>

<p>The <strong><code>Symbol.for(key)</code></strong> method searches for existing symbols in a runtime-wide symbol registry with the given key and returns it if found. Otherwise a new symbol gets created in the global symbol registry with this key.</p>

<div>{{EmbedInteractiveExample("pages/js/symbol-for.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Symbol.for(<var>key</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>key</var></code></dt>
 <dd>String, required. The key for the symbol (and also used for the description of the symbol).</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An existing symbol with the given key if found; otherwise, a new symbol is created and returned.</p>

<h2 id="Description">Description</h2>

<p>In contrast to <code>Symbol()</code>, the <code>Symbol.for()</code> function creates a symbol available in a global symbol registry list. <code>Symbol.for()</code> does also not necessarily create a new symbol on every call, but checks first if a symbol with the given <code>key</code> is already present in the registry. In that case, that symbol is returned. If no symbol with the given key is found, <code>Symbol.for()</code> will create a new global symbol.</p>

<h3 id="Global_symbol_registry">Global symbol registry</h3>

<p>The global symbol registry is a list with the following record structure and it is initialized empty:</p>

<table class="standard-table">
 <caption>A record in the global symbol registry</caption>
 <tbody>
  <tr>
   <th>Field name</th>
   <th>Value</th>
  </tr>
  <tr>
   <td>[[key]]</td>
   <td>A string key used to identify a symbol.</td>
  </tr>
  <tr>
   <td>[[symbol]]</td>
   <td>A symbol that is stored globally.</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Symbol.for">Using Symbol.for()</h3>

<pre class="brush: js notranslate">Symbol.for('foo'); // create a new global symbol
Symbol.for('foo'); // retrieve the already created symbol

// Same global symbol, but not locally
Symbol.for('bar') === Symbol.for('bar'); // true
Symbol('bar') === Symbol('bar'); // false

// The key is also used as the description
var sym = Symbol.for('mario');
sym.toString(); // "Symbol(mario)"
</pre>

<p>To avoid name clashes with your global symbol keys and other (library code) global symbols, it might be a good idea to prefix your symbols:</p>

<pre class="brush: js notranslate">Symbol.for('mdn.foo');
Symbol.for('mdn.bar');
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-symbol.for', 'Symbol.for')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Symbol.for")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Symbol.keyFor()")}}</li>
</ul>
